--script for divan.tv (03/11/2015)

   local UpdateID
   local UseLocalLogo = nil

if UseLocalLogo == nil then
   local fhandle = io.open (m_simpleTV.MainScriptDir ..  "user/tvplaylists/tvmenu.ini")   
   if fhandle == nil then 
      UseLocalLogo = '1'
      return
   end
   local str = fhandle:read('*a')
   fhandle:close()

   UseLocalLogo = string.match(str,'UseLocalLogo=(%d);')
   if UseLocalLogo == nil then UseLocalLogo = 0 end
end

if UseLocalLogo == '1' then
   local sqlstr = 'Select main.id,main.pict from main where main.updateid like "%Divan_%";'
   local dTable = m_simpleTV.Database.GetTable(sqlstr)
   if dTable ~= nil and dTable[1] ~= nil then
     for k, v in ipairs(dTable) do 
        --debug_in_file(v.id .. '  ' .. v.pict .. '\n')
        m_simpleTV.Database.ExecuteSql('DELETE FROM Main WHERE (Main.Id=' .. v.id .. ');',true) 
     end
   end
end
-----------------------------------------------
 local session = m_simpleTV.WinInet.New("Opera/9.80 (Windows NT 6.1; U; ru) Presto/2.9.168 Version/11.52")
 if session == nil then return end

  --INTERNET_OPTION_CONNECT_TIMEOUT
  m_simpleTV.WinInet.SetOptionInt(session,2,5000,0)
  --INTERNET_OPTION_RECEIVE_TIMEOUT
  m_simpleTV.WinInet.SetOptionInt(session,6,8000,0)
-------------------------------------------
local tt={
{"Ukraine channels","http://divan.tv/tv/viewCategoryChannels"},
{"Russian channels","http://divan.tv/ru/tv/viewCategoryChannels"}
}
local url,grp
local t ={}
for i=1,#tt do
      t[i] = {}
      t[i].Id   =  i
      t[i].Name =  tt[i][1]
      t[i].Adress  = tt[i][2]
  end
local ret,id = m_simpleTV.OSD.ShowSelect('Select region',0,t,10000,1+4+8)
     if ret==1 then 
	 url = t[id].Adress
         if string.match(url,'ru') then  grp = 'Divan (Russian)' UpdateID='Divan_RusTV01' else grp = 'Divan (Ukraine)' UpdateID='Divan_UkrTV01' end
      end
if ret ~=1 then return end

 m_simpleTV.OSD.ShowMessage("Divan - start channels updating" ,0xFF00,10)

local  rc,answer=m_simpleTV.WinInet.Get(session,url)
m_simpleTV.WinInet.Close(session)

 if rc~=200 then
	   m_simpleTV.WinInet.Close(session)
	   m_simpleTV.OSD.ShowMessage("Connection error - " .. rc ,255,10)
	   return
 end

--debug_in_file(answer ..  '\n')

local m3ustr = '#EXTM3U\n'
local name,adr,img
--local grp = 'Divan'

 for w in string.gmatch(answer,'<div class="all%-channel%-item">(.-)</a>') do

	adr = findpattern (w,'href="(.-)"',1,6,1)
	name = findpattern (w,'span  title="(.-)"',1,13,1)
        if name == nil then
           name = findpattern (w,'class="name">(.-)<',1,13,1)
	end
 	img = findpattern (w,'<img src="(.-)"',1,10,1)     
	if adr == nil or name == nil or img == nil then break end
	adr = 'http://divan.tv' .. adr


          if UseLocalLogo == '1' then    

              m3ustr = m3ustr .. '#EXTINF:-1 update-code="' .. UpdateID .. grp .. name .. '" group-title="' .. grp .. '",' .. name .. '\n' .. adr .. '\n'

           elseif UseLocalLogo ~= '1' then

             m3ustr = m3ustr .. '#EXTINF:-1 update-code="' .. UpdateID .. grp .. name .. '" group-title="' .. grp .. '" tvg-logo="' .. img .. '",' .. name .. '\n' .. adr .. '\n'

         end

 end

--debug_in_file(m3ustr)

--do return end
m_simpleTV.WinInet.Close(session)

local  tmpName = m_simpleTV.Common.GetTmpName()
if tmpName == nil then return end 

 local tfile = io.open(tmpName,'w+')
 if tfile == nil then 
     os.remove(tmpName)
     return
 end

 tfile:write(m3ustr)
 tfile:close() 


  --опции  для загрузки плейлиста 
local p={}
p.TypeSourse = 1
p.DeleteBeforeLoad = 0
p.TypeSkip   = 1
p.TypeFind =   0
p.AutoSearch = 1
p.NumberM3U =  1
p.Find_Group = 1
p.TypeCoding = 1  --  -1-auto  0 - plane text  1- UTF8  2- unicode
p.BorpasFileFormat=1
p.AutoNumber = 0
p.ExtFilter = 'Divan'
p.ExtFilterLogo =  '..\\Channel\\logo\\extFiltersLogo\\divan.png'   -- the logo of extended filter (from ver. 0.4.8 b9)
p.ExtFilterLogoForce = 0
p.UpdateID=UpdateID

local err,add,ref,names = m_simpleTV.Common.LoadPlayList (tmpName,p,0,true,false)
os.remove(tmpName)

if err==true then
     local mess = "Divan - channels updated (" .. add .. ")"
	 if add > 0 and add < 25 then 
	    names = string.gsub(names,'%$end','\n')
		mess = mess .. '\n' .. names
	 end
	 
	 m_simpleTV.OSD.ShowMessage(mess,0x37BEDF,3) 
  end